// I}bv쐬eXg
#pragma comment (lib, "d3d9.lib")
#pragma comment (lib, "d3dx9.lib")

#include <windows.h>
#include <tchar.h>
#include <d3d9.h>
#include <d3dx9.h>
#include <vector>

TCHAR gName[100] = _T("I}bv쐬eXg");

struct Model {
	ID3DXMesh *mesh;
	D3DXMATRIX local, world;
	float rotX, rotY, rotDef;
	Model() : mesh(), rotX(), rotY(),rotDef(0.001f) {
	}
	~Model() {
		if (mesh)
			mesh->Release();
	}
	void update() {
		rotX += rotDef;
		rotY += rotDef * 0.52764f;
		D3DXMatrixRotationYawPitchRoll(&world, rotY, rotX, 0.0f);
		world = local * world;
	}
	void draw(IDirect3DDevice9 *dev) {
		dev->SetTransform(D3DTS_WORLD, &world);
		mesh->DrawSubset(0);
	}
};

std::vector<Model*> models;

// XV
void update() {
	for (unsigned i = 0; i < models.size(); i++)
		models[i]->update();
}

// wi`
void draw(IDirect3DDevice9 *dev) {
	for (unsigned i = 0; i < models.size(); i++)
		models[i]->draw(dev);
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT mes, WPARAM wParam, LPARAM lParam){
   if(mes == WM_DESTROY) {PostQuitMessage(0); return 0;}
   return DefWindowProc(hWnd, mes, wParam, lParam);
}

int APIENTRY _tWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow)
{
   MSG msg; HWND hWnd;
   WNDCLASSEX wcex ={sizeof(WNDCLASSEX), CS_HREDRAW | CS_VREDRAW, WndProc, 0, 0, hInstance, NULL, NULL,
                                  (HBRUSH)(COLOR_WINDOW+1), NULL, (TCHAR*)gName, NULL};
   if(!RegisterClassEx(&wcex)) return 0;

   int w = 800, h = 600;
   RECT r = {0, 0, w, h};
   ::AdjustWindowRect(&r, WS_OVERLAPPEDWINDOW, FALSE);
   if(!(hWnd = CreateWindow(gName, gName, WS_OVERLAPPEDWINDOW, CW_USEDEFAULT, 0, r.right - r.left, r.bottom - r.top,
         NULL, NULL, hInstance, NULL)))
      return 0;

   // Direct3D̏
   LPDIRECT3D9 g_pD3D;
   LPDIRECT3DDEVICE9 g_pD3DDev;
   if( !(g_pD3D = Direct3DCreate9( D3D_SDK_VERSION )) ) return 0;

   D3DPRESENT_PARAMETERS d3dpp = {w,h,D3DFMT_UNKNOWN,0,D3DMULTISAMPLE_NONE,0,
                                                   D3DSWAPEFFECT_DISCARD,NULL,TRUE,0,D3DFMT_UNKNOWN,0,0};
   d3dpp.EnableAutoDepthStencil = TRUE;
   d3dpp.AutoDepthStencilFormat = D3DFMT_D24S8;

   if( FAILED( g_pD3D->CreateDevice( D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd,
                                                   D3DCREATE_SOFTWARE_VERTEXPROCESSING, &d3dpp, &g_pD3DDev ) ) )
      {g_pD3D->Release(); return 0;}

   // GtFNg쐬
   ID3DXEffect *effect = 0;
   ID3DXBuffer *error = 0;
   D3DXCreateEffectFromFileA(g_pD3DDev, "env.fx", 0, 0, 0, 0, &effect, &error);
   if (error) {
	   OutputDebugStringA((const char*)error->GetBufferPointer());
	   return 0;
   }

   // L[u}bveNX`쐬
   IDirect3DCubeTexture9 *cubeTex = 0;
   D3DXCreateCubeTextureFromFile(g_pD3DDev, "TestCube.dds", &cubeTex);
   if (!cubeTex)
	   return 0;

   // IL[u}bveNX`쐬
   IDirect3DCubeTexture9 *dynamicCubeTex = 0;
   g_pD3DDev->CreateCubeTexture(512, 1, D3DUSAGE_RENDERTARGET, D3DFMT_A8R8G8B8, D3DPOOL_DEFAULT, &dynamicCubeTex, NULL);
   if (!dynamicCubeTex)
	   return 0;

   // f쐬
   const unsigned nbModel = 300;
   int iniDist = 50, dist = 500;
   for (unsigned i = 0; i < nbModel; i++) {
	   Model *newModel = new Model;
	   Model &model = *newModel;
	   if (rand() % 2)
		   D3DXCreateSphere(g_pD3DDev, 10.0f + (float)(rand() % 30), 10, 10, &model.mesh, 0);
	   else
		   D3DXCreateBox(g_pD3DDev, 40.0f, 40.0f, 40.0f, &model.mesh, 0);
	   D3DXMatrixTranslation(&model.local,
		   (rand() % 2 * 2 - 1) * (iniDist + rand() % dist),
		   (rand() % 2 * 2 - 1) * (iniDist + rand() % dist),
		   (rand() % 2 * 2 - 1) * (iniDist + rand() % dist)
	   );
	   model.rotDef = 0.0001f + 0.01f * (float)rand() / RAND_MAX;
	   models.push_back(newModel);
   }

   // Z^[f
   Model center;
   D3DXCreateSphere(g_pD3DDev, 100.0f, 40, 40, &center.mesh, 0);
   D3DXMatrixTranslation(&center.local, 0.0f, 0.0f, 0.0f);
   center.rotDef = 0.0f;

   // J̌ƃAbvxNg
   D3DXVECTOR3 lookAt[6] = {
	   D3DXVECTOR3( 1.0f,  0.0f,  0.0f),	// +X
	   D3DXVECTOR3(-1.0f,  0.0f,  0.0f),	// -X
	   D3DXVECTOR3( 0.0f,  1.0f,  0.0f),	// +Y
	   D3DXVECTOR3( 0.0f, -1.0f,  0.0f),	// -Y
	   D3DXVECTOR3( 0.0f,  0.0f,  1.0f),	// +Z
	   D3DXVECTOR3( 0.0f,  0.0f, -1.0f) 	// -Z
   };
   D3DXVECTOR3 up[6] = {
	   D3DXVECTOR3( 0.0f,  1.0f,  0.0f),	// +X(Up = +Y)
	   D3DXVECTOR3( 0.0f,  1.0f,  0.0f),	// -X(Up = +Y)
	   D3DXVECTOR3( 0.0f,  0.0f, -1.0f),	// +Y(Up = -Z)
	   D3DXVECTOR3( 0.0f,  0.0f,  1.0f),	// -X(Up = +Z)
	   D3DXVECTOR3( 0.0f,  1.0f,  0.0f),	// +Z(Up = +Y)
	   D3DXVECTOR3( 0.0f,  1.0f,  0.0f),	// -Z(Up = +Y)
   };

   // }eA
   D3DMATERIAL9 mat = {{1.0f, 1.0f, 1.0f, 1.0f}};
   g_pD3DDev->SetMaterial(&mat);

   // Cg
   D3DLIGHT9 light;
   memset(&light, 0, sizeof(light));
   light.Type = D3DLIGHT_DIRECTIONAL;
   D3DCOLORVALUE diffuse = {1.0f, 1.0f, 1.0f, 1.0f};
   light.Diffuse = diffuse;
   light.Direction = (D3DVECTOR)D3DXVECTOR3(1.0f, -1.0f, 1.0f);
   g_pD3DDev->SetLight(0, &light);
   g_pD3DDev->LightEnable( 0, true );
   g_pD3DDev->SetRenderState(D3DRS_LIGHTING, TRUE);

   ShowWindow(hWnd, nCmdShow);

   // bZ[W [v
   do{
      if( PeekMessage(&msg, NULL, 0, 0, PM_REMOVE) ){ DispatchMessage(&msg);}
      else{
			   // XV
			   update();

               // `
			   g_pD3DDev->BeginScene();

			   // I}bvփ_O
			   for (unsigned i = 0; i < 6; i++) {
				   // T[tFCXw
				   IDirect3DSurface9 *renderTarget, *oldTarget;
				   dynamicCubeTex->GetCubeMapSurface((D3DCUBEMAP_FACES)i, 0, &renderTarget);
				   renderTarget->Release();
				   g_pD3DDev->GetRenderTarget(0, &oldTarget);
				   oldTarget->Release();
				   g_pD3DDev->SetRenderTarget(0, renderTarget);

				   // r[s쐬
				   D3DXMATRIX view;
				   D3DXMatrixLookAtLH(&view, &D3DXVECTOR3(0.0f, 0.0f, 0.0f), &lookAt[i], &up[i]);

				   // p[XyNeBu90x
				   D3DXMATRIX proj;
				   D3DXMatrixPerspectiveFovLH(&proj, D3DXToRadian(90.0f), 1.0f, 1.0f, 10000.0f);

				   g_pD3DDev->SetTransform(D3DTS_VIEW, &view);
				   g_pD3DDev->SetTransform(D3DTS_PROJECTION, &proj);

				   // Direct3D̏
				   g_pD3DDev->Clear( 0, NULL, D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER | D3DCLEAR_STENCIL, D3DCOLOR_XRGB(0,0,0), 1.0f, 0 );

				   // BeX^[g
					draw(g_pD3DDev);

					g_pD3DDev->SetRenderTarget(0, oldTarget);
			   }

			   // ʏV[`
			   g_pD3DDev->Clear( 0, NULL, D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER | D3DCLEAR_STENCIL, D3DCOLOR_XRGB(0,0,0), 1.0f, 0 );
			   D3DXMATRIX view;
			   static float a = 0.0f; a -= 0.004f;
			   D3DXVECTOR3 cameraPosW(500.0f * sinf(a), 0.0f, -500.0f * cosf(a));
			   D3DXMatrixLookAtLH(&view, &cameraPosW, &D3DXVECTOR3(0.0f, 0.0f, 0.0f), &D3DXVECTOR3(0.0f, 1.0f, 0.0f));
			   D3DXMATRIX proj;
			   D3DXMatrixPerspectiveFovLH(&proj, D3DXToRadian(30.0f), (float)w / h, 1.0f, 10000.0f);

			   g_pD3DDev->SetTransform(D3DTS_VIEW, &view);
			   g_pD3DDev->SetTransform(D3DTS_PROJECTION, &proj);

			   // Ӄf`
			   draw(g_pD3DDev);

			   // Z^[fɊ}bvKpĕ`
			   center.update();
			   effect->SetTechnique("tech");
			   UINT nbPass = 0;
			   effect->Begin(&nbPass, 0);
			   effect->BeginPass(0);
			   effect->SetMatrix("view", &view);
			   effect->SetMatrix("proj", &proj);
			   effect->SetMatrix("world", &center.world);
			   effect->SetVector("cameraPosW", &D3DXVECTOR4(cameraPosW, 1.0f));
			   effect->SetTexture("cubeTex", dynamicCubeTex);
			   effect->SetTexture("staticCubeTex", cubeTex);
			   center.draw(g_pD3DDev);
			   effect->EndPass();
			   effect->End();

               g_pD3DDev->EndScene();
               g_pD3DDev->Present( NULL, NULL, NULL, NULL );
            }
   }while(msg.message != WM_QUIT);

   effect->Release();
   cubeTex->Release();
   dynamicCubeTex->Release();
   for (unsigned i = 0; i < models.size(); i++)
	   delete models[i];
   g_pD3DDev->Release();
   g_pD3D->Release();

   return 0;
}